/*****************************************************************************
 *
 * File:        main.cpp
 *
 * Author:      Sven Mulka
 *
 * Company:     Ingenieurbro Mulka, Software & Data Communication
 *              Copyright (c) 2018, by IB-Mulka
 *              http://www.ib-mulka.de
 *
 * Content:     Test Application to trigger some issue of
 *              * linker
 *              * CCS debugger
 *              * RBL
 *
 * Changes:
 * 17.07.18 SM  Initial Version
 *
 *****************************************************************************/
/*
 * $Log:   $
 */
#include <iostream>
#include <iomanip>
#include <complex>

using namespace std;

/*****************************************************************************/

bool test_fill();
bool test_data_binit();
bool test_code_binit();

volatile bool g_wait = true;

int main(void)
{
    while (1)
    {
        g_wait = true;

        cout << endl
             << "********************************************************" << endl
             << "Set g_wait to 0 via debugger to run the tests." << endl
             << "********************************************************" << endl
             << endl;

        /***
         * After RBL booting we have to wait until CCS debugger is connected.
         * The user have to set the global g_wait variable to false to run
         * the tests.
         */
        while (g_wait) {};

    	test_fill();
    	test_data_binit();
        test_code_binit();

        cout << endl
             << "********************************************************" << endl
             << "Stop" << endl
             << "********************************************************" << endl
             << endl;
    }

	return 0;
}

/*****************************************************************************/
