/*****************************************************************************
 *
 * File:        test_code_binit.cpp
 *
 * Author:      Sven Mulka
 *
 * Company:     Ingenieurbro Mulka, Software & Data Communication
 *              Copyright (c) 2018, by IB-Mulka
 *              http://www.ib-mulka.de
 *
 * Content:     Test to trigger BINIT issue, where breakpoint can not be
 *              set in C++ classes.
 *
 * Changes:
 * 17.07.18 SM  Initial Version
 *
 *****************************************************************************/
/*
 * $Log:   $
 */
#include <cpy_tbl.h>
#include <iostream>
#include <iomanip>

using namespace std;

/*****************************************************************************/
namespace test { namespace binit {
/*****************************************************************************/

#pragma SET_CODE_SECTION("test_code.binit")

class code_binit
{
public:
    code_binit() {}

    virtual ~code_binit() {}

    virtual void run();
};


//virtual
void code_binit::run()
{
    cout << endl
         << "... done"  << endl
         << "********************************************************" << endl
         << endl
         ;
}

/*****************************************************************************/
}};     // namespace test::binit
/*****************************************************************************
 * Run BINIT test for code.
 */
extern _DATA_ACCESS COPY_TABLE const test_code_binit_table[];

#pragma SET_CODE_SECTION()
bool test_code_binit()
{
    using namespace std;

    cout << endl
         << "********************************************************" << endl
         << "Running test.code.binit ..." << endl
         << endl
         ;

    /***
     * Load binit code from compressed section
     */
    copy_in((COPY_TABLE *)test_code_binit_table);

    /***
     * Run loaded code.
     */
    test::binit::code_binit test;
    test.run();

    return true;
}

/*****************************************************************************/
